#version 330

// It is OK we set only 'xyz' components from CPU. 'w' is set to 1 by default in that case
in vec4 position;

// TASK 7: Uncomment to add a simple light. Will be explained later.
/*
in vec3 normal;
out vec3 VS_normal;
uniform mat3 normal_matrix;
*/

uniform float aspect;

//uniform vec3 model_position;

void main()
{
    vec4 pin = position;
    vec4 pout;

    // TASK 2: Model transformation. Move object as specified by model_position.
    //   Don't forget to declare the uniform and actually pass data to it
    /*
    pout.xyz = pin.xyz + model_position;
    pout.w = pin.w;
    pin = pout;
    */

    // TASK 4: View transformation. Raise the hypothetical camera.
    //   There is no actual camera to move; you move the whole world instead.
    /*
    pout.xyz = pin.xyz - vec3(0.0, 1.5, 0.0);
    pout.w = pin.w;
    pin = pout;
    */

    // Projection transformation.
    // TASK 1: Flip the 'z' axis and halve x, y and z coordinates.
    //   OpenGL's NDC (normalised device coordinates) system uses z range of
    //   [-1.0, 1.0] (unlike Direct3D) with -1.0 being "closest to you" and 1.0
    //   being "behind the screen". It is, however, common to use a
    //   right-handed base, thus we flip the z axis. Downsizing the coordinates
    //   makes the box smaller since it currently covers the whole screen.
    // TASK 2: Halve the coordinates again. (-> 1/4 of the original)
    // TASK 3: Make farther objects seem smaller.
    //   Hint 1: divide coordinates by a factor linearly dependant on pin.z.
    //   Hint 2: you don't need to divide, if you use homogeneous coords.
    pout.x = pin.x / aspect;
    pout.y = pin.y;
    pout.z = pin.z;
    pout.w = pin.w;

    // TASK 5: Use matrices for all the transformations above. That means you
    // need to add uniforms and fill them with data from C++ code. Mind proper
    // order of multiplication!

    // TASK 6: Use single PVM_matrix instead, do the multiplying in C++ code.

    gl_Position = pout;


    // TASK 7: Uncomment.
    //VS_normal = normal_matrix * normal;
}

/*
pout.x = pin.x * 0.25 / aspect;
pout.y = pin.y * 0.25;
pout.z = pin.z * 0.25 * -1.0f;
pout.w = -pin.z * 0.2 + 1.1;
*/
